#!/usr/bin/env python
# -*- coding:utf-8 -*-
# @FileName  :z_power.py
# @Time      :2024/12/30 14:16
# @Author    :David
# @Company: shenyang JY
import os, pickle

c_names = ['G01', 'G02', 'G03', 'G04', 'G05', 'G06', 'G07', 'G08', 'G09', 'G10'] + ['G' + str(x) for x in range(11, 76)]
turbineloc = [x for x in range(76, 151, 1)]
id_names = {id: c_names[x] for x, id in enumerate(turbineloc)}
path = '../../cluster/260/turbine_cls.pickle'
with open(path, 'rb') as f:
    turbine_cls = pickle.load(f)

def turbine_cls_adjust(turbine_cls):
    turbine_cls[2] = [x for x in turbine_cls[2] if x != 'G54']
    turbine_cls[1].append('G54')
    turbine_cls[2].append('G14')
    del turbine_cls[3]
    with open(path, 'wb') as file:
        pickle.dump(turbine_cls, file)

def zone_powers(input_dir):
    z_power = {}
    for zone, turbines in turbine_cls.items():
        dfs = [pd.read_csv(os.path.join(input_dir, f"turbine-{z}.csv")) for z in turbineloc if id_names[z] in turbines]
        z_power['C_TIME'] = dfs[0]['C_TIME']
        sum_power = pd.concat([df['C_ACTIVE_POWER'] for df in dfs], ignore_index=True, axis=1).sum(axis=1)
        z_power[zone] = sum_power/1000
    z_power = pd.DataFrame(z_power)
    z_power.iloc[:, 1:] = z_power.iloc[:, 1:].round(2)
    z_power.to_csv("../../cluster/260/z-power.csv", index=False)



if __name__ == "__main__":
    import pandas as pd
    # turbine_cls_adjust(turbine_cls)
    zone_powers("../../cluster/260/")